Attribute VB_Name = "MU_Selection"

Option Explicit

' sample save dialog code found at http://msdn.microsoft.com/library/default.asp?url=/library/en-us/dnovba00/html/CommonDialogsPartI.asp

Private Type OPENFILENAME
  lStructSize       As Long
  hwndOwner         As Long
  hInstance         As Long
  lpstrFilter       As String
  lpstrCustomFilter As String
  nMaxCustFilter    As Long
  nFilterIndex      As Long
  lpstrFile         As String
  nMaxFile          As Long
  lpstrFileTitle    As String
  nMaxFileTitle     As Long
  lpstrInitialDir   As String
  lpstrTitle        As String
  Flags             As Long
  nFileOffset       As Integer
  nFileExtension    As Integer
  lpstrDefExt       As String
  lCustData         As Long
  lpfnHook          As Long
  lpTemplateName    As String
End Type

Private Declare Function GetSaveFileName _
  Lib "COMDLG32.DLL" Alias "GetSaveFileNameA" _
  (pOpenfilename As OPENFILENAME) As Long

' By Carl Johnson 5/4/2006
' Based upon Sample code found at http://edndoc.esri.com/arcobjects/8.3/


Public Sub WriteSelectionToMUFile()
  ' ArcMap objects
  Dim pMxDoc As IMxDocument
  Dim pMap As IMap
  Dim pFeatureSetup As IEnumFeatureSetup
  Dim pEnumFeature As IEnumFeature
  Dim pFeature As IFeature
    
  'Temporary storage
  Dim strMsmNode() As String, strMsmLink() As String, _
      strMsmPump() As String, strMsmWeir() As String, _
      strMsmOrifice() As String, strMsmValve() As String, _
      strMsCatchment() As String, strMwJunction() As String, _
      strMwPipe() As String, strMwPump() As String, _
      strMwTank() As String, strMwValve() As String, _
      strMwDemAlloc() As String

  Dim lngMsmNode As Long, lngMsmLink As Long, lngMsmPump As Long, _
      lngMsmWeir As Long, lngMsmValve As Long, lngMsmOrifice As Long, _
      lngMsCatchment As Long, lngMwJunction As Long, lngMwPipe As Long, _
      lngMwPump As Long, lngMwTank As Long, lngMwValve As Long, _
      lngMwDemAlloc As Long
            
  Dim lngMsmNodeFieldNo As Long, lngMsmLinkFieldNo As Long, _
      lngMsmPumpFieldNo As Long, lngMsmWeirFieldNo As Long, _
      lngMsmValveFieldNo As Long, lngMsmOrificeFieldNo As Long, _
      lngMsCatchmentFieldNo As Long, lngMwJunctionFieldNo As Long, _
      lngMwPipeFieldNo As Long, lngMwPumpFieldNo As Long, lngMwTankFieldNo As Long, _
      lngMwValveFieldNo As Long, lngMwDemAllocFieldNo As Long

  lngMsmNode = 0
  lngMsmLink = 0
  lngMsmPump = 0
  lngMsmWeir = 0
  lngMsmValve = 0
  lngMsmOrifice = 0
  lngMsCatchment = 0
  lngMwJunction = 0
  lngMwPipe = 0
  lngMwPump = 0
  lngMwTank = 0
  lngMwValve = 0
  lngMwDemAlloc = 0
      
  Set pMxDoc = Application.Document
  Set pMap = pMxDoc.FocusMap
  Set pEnumFeature = pMap.FeatureSelection
  Set pFeatureSetup = pEnumFeature
  
  pFeatureSetup.AllFields = True
  pEnumFeature.Reset
  Set pFeature = pEnumFeature.Next
  
    ReDim strMsmNode(pMap.SelectionCount)
    ReDim strMsmLink(pMap.SelectionCount)
    ReDim strMsmPump(pMap.SelectionCount)
    ReDim strMsmWeir(pMap.SelectionCount)
    ReDim strMsmOrifice(pMap.SelectionCount)
    ReDim strMsmValve(pMap.SelectionCount)
    ReDim strMsCatchment(pMap.SelectionCount)
    ReDim strMwJunction(pMap.SelectionCount)
    ReDim strMwPipe(pMap.SelectionCount)
    ReDim strMwPump(pMap.SelectionCount)
    ReDim strMwTank(pMap.SelectionCount)
    ReDim strMwValve(pMap.SelectionCount)
    ReDim strMwDemAlloc(pMap.SelectionCount)
    
  While Not pFeature Is Nothing
    If pFeature.Class.AliasName Like "msm_Node" Then
        If lngMsmNode = 0 Then lngMsmNodeFieldNo = pFeature.Table.FindField("MUID")
        strMsmNode(lngMsmNode) = pFeature.Value(lngMsmNodeFieldNo)
        lngMsmNode = lngMsmNode + 1
        
    ElseIf pFeature.Class.AliasName Like "msm_Link" Then
        If lngMsmLink = 0 Then lngMsmLinkFieldNo = pFeature.Table.FindField("MUID")
        strMsmLink(lngMsmLink) = pFeature.Value(lngMsmLinkFieldNo)
        lngMsmLink = lngMsmLink + 1
    
    ElseIf pFeature.Class.AliasName Like "msm_Pump" Then
        If lngMsmPump = 0 Then lngMsmPumpFieldNo = pFeature.Table.FindField("MUID")
        strMsmPump(lngMsmPump) = pFeature.Value(lngMsmPumpFieldNo)
        lngMsmPump = lngMsmPump + 1
    
    ElseIf pFeature.Class.AliasName Like "msm_Weir" Then
        If lngMsmWeir = 0 Then lngMsmWeirFieldNo = pFeature.Table.FindField("MUID")
        strMsmWeir(lngMsmWeir) = pFeature.Value(lngMsmWeirFieldNo)
        lngMsmWeir = lngMsmWeir + 1
    
    ElseIf pFeature.Class.AliasName Like "msm_Orifice" Then
        If lngMsmOrifice = 0 Then lngMsmOrificeFieldNo = pFeature.Table.FindField("MUID")
        strMsmOrifice(lngMsmOrifice) = pFeature.Value(lngMsmOrificeFieldNo)
        lngMsmOrifice = lngMsmOrifice + 1

    ElseIf pFeature.Class.AliasName Like "msm_Valve" Then
        If lngMsmValve = 0 Then lngMsmValveFieldNo = pFeature.Table.FindField("MUID")
        strMsmValve(lngMsmValve) = pFeature.Value(lngMsmValveFieldNo)
        lngMsmValve = lngMsmValve + 1
 
    ElseIf pFeature.Class.AliasName Like "ms_Catchment" Then
        If lngMsCatchment = 0 Then lngMsCatchmentFieldNo = pFeature.Table.FindField("MUID")
        strMsCatchment(lngMsCatchment) = pFeature.Value(lngMsCatchmentFieldNo)
        lngMsCatchment = lngMsCatchment + 1
 
    ElseIf pFeature.Class.AliasName Like "mw_Junction" Then
        If lngMwJunction = 0 Then lngMwJunctionFieldNo = pFeature.Table.FindField("MUID")
        strMwJunction(lngMwJunction) = pFeature.Value(lngMwJunctionFieldNo)
        lngMwJunction = lngMwJunction + 1
    
    ElseIf pFeature.Class.AliasName Like "mw_Pipe" Then
        If lngMwPipe = 0 Then lngMwPipeFieldNo = pFeature.Table.FindField("MUID")
        strMwPipe(lngMwPipe) = pFeature.Value(lngMwPipeFieldNo)
        lngMwPipe = lngMwPipe + 1
    
    ElseIf pFeature.Class.AliasName Like "mw_Pump" Then
        If lngMwPump = 0 Then lngMwPumpFieldNo = pFeature.Table.FindField("MUID")
        strMwPump(lngMwPump) = pFeature.Value(lngMwPumpFieldNo)
        lngMwPump = lngMwPump + 1
    
    ElseIf pFeature.Class.AliasName Like "mw_Tank" Then
        If lngMwTank = 0 Then lngMwTankFieldNo = pFeature.Table.FindField("MUID")
        strMwTank(lngMwTank) = pFeature.Value(lngMwTankFieldNo)
        lngMwTank = lngMwTank + 1
        
    ElseIf pFeature.Class.AliasName Like "mw_Valve" Then
        If lngMwValve = 0 Then lngMwValveFieldNo = pFeature.Table.FindField("MUID")
        strMwValve(lngMwValve) = pFeature.Value(lngMwValveFieldNo)
        lngMwValve = lngMwValve + 1
   
    ElseIf pFeature.Class.AliasName Like "mw_DemAlloc" Then
        If lngMwDemAlloc = 0 Then lngMwDemAllocFieldNo = pFeature.Table.FindField("MUID")
        strMwDemAlloc(lngMwDemAlloc) = pFeature.Value(lngMwDemAllocFieldNo)
        lngMwDemAlloc = lngMwDemAlloc + 1

    End If
    Set pFeature = pEnumFeature.Next
  Wend
  

    ' file output stuff
    
    Const ForReading = 1, ForWriting = 2, ForAppending = 3
    Const TristateUseDefault = -2, TristateTrue = -1, TristateFalse = 0
        
    Dim ofnFile As OPENFILENAME
    Dim fs As Object, fle1 As Object, ts1 As Object
    Dim i As Long
    Dim strFileName As String
     
    With ofnFile
        .lStructSize = Len(ofnFile)     ' Size of structure.
        .nMaxFile = 260             ' Size of buffer.
        ' Create buffer.
        .lpstrFile = String(.nMaxFile - 1, 0)
        .lpstrFilter = "MU Selection File (*.mus)"
        .nFilterIndex = 1
    End With
    
    If GetSaveFileName(ofnFile) = 0 Then Exit Sub
    
    ' create a save name
    If ofnFile.nFileExtension = 0 Then
        i = ofnFile.nFileOffset + 1
        While Asc(Mid(ofnFile.lpstrFile, i, 1)) <> 0
            i = i + 1
        Wend
        
        If i = ofnFile.nFileOffset + 1 Then Exit Sub
        
        strFileName = Mid(ofnFile.lpstrFile, 1, i - 1) & ".mus"
    Else
        strFileName = Mid(ofnFile.lpstrFile, 1, ofnFile.nFileExtension - 1) & ".mus"
    End If
    
    Set fs = CreateObject("Scripting.FileSystemObject")
    fs.createtextfile strFileName
    Set fle1 = fs.GetFile(strFileName)
    Set ts1 = fle1.OpenAsTextStream(ForWriting, TristateUseDefault)
       
    ' write out msm_Nodes
    If lngMsmNode > 0 Then
        ts1.Write "msm_Node"
        For i = 0 To lngMsmNode - 1
            ts1.Write Chr(13) & Chr(10) & strMsmNode(i)
        Next i
        ts1.Write Chr(13) & Chr(10) & Chr(13) & Chr(10)
    End If
    
    ' write out msm_Links
    If lngMsmLink > 0 Then
        ts1.Write "msm_Link"
        For i = 0 To lngMsmLink - 1
            ts1.Write Chr(13) & Chr(10) & strMsmLink(i)
        Next i
        ts1.Write Chr(13) & Chr(10) & Chr(13) & Chr(10)
    End If
    
    ' write out msm_Pumps
    If lngMsmPump > 0 Then
        ts1.Write "msm_Pump"
        For i = 0 To lngMsmPump - 1
            ts1.Write Chr(13) & Chr(10) & strMsmPump(i)
        Next i
        ts1.Write Chr(13) & Chr(10) & Chr(13) & Chr(10)
    End If
    
    ' write out msm_Orifices
    If lngMsmOrifice > 0 Then
        ts1.Write "msm_Orifice"
        For i = 0 To lngMsmOrifice - 1
            ts1.Write Chr(13) & Chr(10) & strMsmOrifice(i)
        Next i
        ts1.Write Chr(13) & Chr(10) & Chr(13) & Chr(10)
    End If
    
    ' write out Msm_Valves
    If lngMsmValve > 0 Then
        ts1.Write "msm_Valve"
        For i = 0 To lngMsmValve - 1
            ts1.Write Chr(13) & Chr(10) & strMsmValve(i)
        Next i
        ts1.Write Chr(13) & Chr(10) & Chr(13) & Chr(10)
    End If
    
    ' write out Msm_Weirs
    If lngMsmWeir > 0 Then
        ts1.Write "msm_Weir"
        For i = 0 To lngMsmWeir - 1
            ts1.Write Chr(13) & Chr(10) & strMsmWeir(i)
        Next i
        ts1.Write Chr(13) & Chr(10) & Chr(13) & Chr(10)
    End If
    
    
    ' write out ms_Catchments
    If lngMsCatchment > 0 Then
        ts1.Write "ms_Catchment"
        For i = 0 To lngMsCatchment - 1
            ts1.Write Chr(13) & Chr(10) & strMsCatchment(i)
        Next i
       ts1.Write Chr(13) & Chr(10) & Chr(13) & Chr(10)
    End If
    
    ' write out mw_Junctions
    If lngMwJunction > 0 Then
        ts1.Write "mw_Junction"
        For i = 0 To lngMwJunction - 1
            ts1.Write Chr(13) & Chr(10) & strMwJunction(i)
        Next i
        ts1.Write Chr(13) & Chr(10) & Chr(13) & Chr(10)
    End If
    
    ' write out mw_Pipes
    If lngMwPipe > 0 Then
        ts1.Write "mw_Pipe"
        For i = 0 To lngMwPipe - 1
            ts1.Write Chr(13) & Chr(10) & strMwPipe(i)
        Next i
        ts1.Write Chr(13) & Chr(10) & Chr(13) & Chr(10)
    End If
    
    ' write out mw_Pumps
    If lngMwPump > 0 Then
        ts1.Write "mw_Pump"
        For i = 0 To lngMwPump - 1
            ts1.Write Chr(13) & Chr(10) & strMwPump(i)
        Next i
        ts1.Write Chr(13) & Chr(10) & Chr(13) & Chr(10)
    End If
    
    ' write out mw_Valves
    If lngMwValve > 0 Then
        ts1.Write "mw_Valve"
        For i = 0 To lngMwValve - 1
            ts1.Write Chr(13) & Chr(10) & strMwValve(i)
        Next i
        ts1.Write Chr(13) & Chr(10) & Chr(13) & Chr(10)
    End If
    
    ' write out mw_Tanks
    If lngMwTank > 0 Then
        ts1.Write "mw_Tank"
        For i = 0 To lngMwTank - 1
            ts1.Write Chr(13) & Chr(10) & strMwTank(i)
        Next i
        ts1.Write Chr(13) & Chr(10) & Chr(13) & Chr(10)
    End If
    
    ' write out mw_DemAlloc
    If lngMwDemAlloc > 0 Then
        ts1.Write "mw_DemAlloc"
        For i = 0 To lngMwDemAlloc - 1
            ts1.Write Chr(13) & Chr(10) & strMwDemAlloc(i)
        Next i
    End If
    
    ts1.Close
    Set fle1 = Nothing
    Set fs = Nothing

MsgBox "Task completed"

End Sub


